<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 12/12/2008 *
 * ===================                          Last change: 12/12/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : pool-user.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Sends queued user mails from the pool            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet freigegebene Mitglieder-Mails aus Pool    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Don't run on daily reset
if ((isResetModeEnabled()) || (!isHtmlOutputMode())) {
	// Skip here
	return FALSE;
} elseif (!isExtensionActive('user')) {
	// Abort here if extension user is not active
	return FALSE;
}

// No HTML is default
$HTML = '';

// Check for freed mail orders to send out
if (isExtensionActive('html_mail')) {
	// With HTML mails
	$HTML = ',`html_msg`';
} // END - if

// Main query
$result_main = SQL_QUERY("SELECT
	`id`,
	`sender` AS `sender_userid`,
	`subject`,
	`text`,
	`receivers`,
	`payment_id`,
	`timestamp`,
	`url`,
	`target_send`,
	`cat_id`
	".$HTML."
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`data_type`='NEW'
ORDER BY
	`timestamp` DESC", __FILE__, __LINE__);

// Reset variables
$count2 = '0';
$lastSentId = '0';
$count_back = array(0);
$pointsBack = array(0);

if (!SQL_HASZERONUMS($result_main)) {
	// Parse all mails
	while ($mailData = SQL_FETCHARRAY($result_main)) {
		// Set mail order as 'active'. That means it will be sent out
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='ACTIVE' WHERE `id`=%s AND `data_type`='NEW' LIMIT 1",
			array($mailData['id']), __FILE__, __LINE__);

		// Check fetched data for HTML
		$isHtml = 'N';
		if (isset($mailData['html_msg'])) $isHtml = $mailData['html_msg'];

		// Entry updated?
		if (!SQL_HASZEROAFFECTED()) {
			// "Explode" all receivers into an array
			if (isInString(';', $mailData['receivers'])) {
				// There's more than one receiver in the list...
				$receivers = explode(';', $mailData['receivers']);
			} elseif (!empty($mailData['receivers'])) {
				// Only one user left
				$receivers = array($mailData['receivers']);
			} else {
				// No users left
				$receivers = array(0);
			}
			$temporaryReceivers = $receivers;

			// Now, if we are good little boys and girls Santa Claus left us some user-ids.
			// We can now send mails to them...
			foreach ($receivers as $key => $userid) {
				// Lookup user id
				//* DEBUG: */ debugOutput('*L:'.__LINE__.'/'.SQL_NUMROWS($result_user).'*');
				if (fetchUserData($userid)) {
					// Is there a stats entry?
					$result_stats = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s AND `userid`=%s AND timestamp_ordered='%s' LIMIT 1",
						array($mailData['id'], $mailData['sender_userid'], $mailData['timestamp']), __FILE__, __LINE__);

					// If there's no stats entry add it!
					//* DEBUG: */ debugOutput('!L:'.__LINE__.'/'.SQL_NUMROWS($result_stats).'!');
					if (SQL_HASZERONUMS($result_stats)) {
						// No entry was found, so we add him!
						SQL_QUERY_ESC("INSERT INTO
	`{?_MYSQL_PREFIX?}_user_stats`
(
	`pool_id`,
	`userid`,
	`cat_id`,
	`payment_id`,
	`subject`,
	`url`,
	`max_rec`,
	`timestamp_ordered`,
	`timestamp_sstart`
) VALUES (
	%s,
	%s,
	%s,
	%s,
	'%s',
	'%s',
	%s,
	%s,
	UNIX_TIMESTAMP()
)",
							array(
								bigintval($mailData['id']),
								bigintval($mailData['sender_userid']),
								bigintval($mailData['cat_id']),
								bigintval($mailData['payment_id']),
								$mailData['subject'],
								$mailData['url'],
								bigintval($mailData['target_send']),
								bigintval($mailData['timestamp'])
							), __FILE__, __LINE__);

						// Receive it's id for the links table
						$result_stats = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s AND `userid`=%s AND timestamp_ordered='%s' LIMIT 1",
							array(bigintval($mailData['id']), bigintval($mailData['sender_userid']), bigintval($mailData['timestamp'])), __FILE__, __LINE__);
					} // END - if

					//* DEBUG: */ debugOutput('!L:'.__LINE__.'/'.SQL_NUMROWS($result_stats).'!');
					if (SQL_NUMROWS($result_stats) == 1) {
						// We got one!
						list($stats_id) = SQL_FETCHROW($result_stats);

						// Remove receiver from list
						$status = removeReceiver($temporaryReceivers, $key, bigintval($userid), bigintval($mailData['id']), bigintval($stats_id));

						//* DEBUG: */ debugOutput('?L:'.__LINE__.'/'.$temporaryReceivers.'/'.$key.'/'.$userid.'('.['sender_userid'].')/'.$mailData['id'].'/'.$stats_id.'?');
						switch ($status) {
							case 'done':
								// Prepare the mail
								$mailData['stats_id'] = bigintval($stats_id);

								// Prepare content
								$mailData['time']   = getPaymentData($mailData['payment_id'], 'time');
								$mailData['points'] = getPaymentData($mailData['payment_id'], 'payment');

								// Load message template
								$mailText = loadEmailTemplate('member_user_pool_normal', $mailData, bigintval($userid));

								// Send mail away
								sendEmail(getUserData('userid'), $mailData['subject'], $mailText, $isHtml);

								// Count sent mails...
								SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `emails_sent`=`emails_sent`+1 WHERE `userid`=%s LIMIT 1",
									array(bigintval($mailData['sender_userid'])), __FILE__, __LINE__);

								if (isExtensionInstalledAndNewer('user', '0.1.4')) {
									// Update mails received for receiver
									SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `emails_received`=`emails_received`+1 WHERE `userid`=%s LIMIT 1",
										array(bigintval($userid)), __FILE__, __LINE__);
								} // END - if

								// Update mediadata if version is 0.0.4 or higher
								if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
									// Update entry (or add missing)
									//* DEBUG: */ debugOutput('*MEDIA/L:'.__LINE__.'*');
									updateMediadataEntry(array('total_send', 'normal_send'), 'add', 1);
								} // END - if

								// And count up the mail
								$GLOBALS['pool_cnt']++;
								//* DEBUG: */ debugOutput('*EXIT/L:'.__LINE__.'/'.$GLOBALS['pool_cnt'].'*');
								break;

							case 'already':
								// Entry already found, but we still count one up!
								$GLOBALS['pool_cnt']++;
								//* DEBUG: */ debugOutput('*EXIT/L:'.__LINE__.'/'.$GLOBALS['pool_cnt']);
								break;

							default: // Unknown return type
								logDebugMessage(__FILE__, __LINE__, 'Unknown status ' . $status . ' detected. pool_id=' . $mailData['id'] . ',sender=' . $mailData['sender_userid'] . ',stats_id=' . $stats_id);
								break;
						} // END - switch
					} // END - if

					// Is there reached the maximum to send mails? || (getConfig('max_send') >= $GLOBALS['pool_cnt'])
					//* DEBUG: */ debugOutput('*L:'.__LINE__.'/'.$GLOBALS['pool_cnt'].'>='.$mailData['target_send'].'/'.getConfig('max_send').'>='.$GLOBALS['pool_cnt'].'/'.$lastSentId.'!='.$mailData['id'].'*');
					if ((($GLOBALS['pool_cnt'] >= $mailData['target_send'])) && ($lastSentId != $mailData['id'])) {
						// Prepare content
						$content = array(
							'sender_userid' => $mailData['sender_userid'],
							'cat_id'        => $mailData['cat_id'],
							'text'          => $mailData['text'],
							'url'           => $mailData['url'],
							'expiration'    => '{%pipe,createFancyTime=' . getPaymentData($mailData['payment_id'], 'time') . '%}'
						);

						// Yes we do, so we notify admin and sender about fully sent mail!
						sendAdminNotification('{--ADMIN_SEND_DONE_SUBJECT--}', 'admin_user_pool_done', $content, $userid);

						// Get sender's data
						if (fetchUserData($mailData['sender_userid'])) {
							// Load email template
							$mailText = loadEmailTemplate('member_user_pool_done', $content, $mailData['sender_userid']);

							// Send it also waway
							sendEmail(getUserData('userid'), '{--MEMBER_SEND_DONE_SUBJECT--}', $mailText);
						} // END - if

						// Set status to SEND because we completely send it away
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='SEND',`target_send`=0,`receivers`='' WHERE `id`=%s LIMIT 1",
							array(bigintval($mailData['id'])), __FILE__, __LINE__);

						// Update send-completed-time
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_stats` SET `timestamp_send`=UNIX_TIMESTAMP() WHERE `pool_id`=%s LIMIT 1",
							array(bigintval($mailData['id'])), __FILE__, __LINE__);

						$lastSentId = $mailData['id']; $GLOBALS['pool_cnt'] = '0';
						$count2 += $GLOBALS['pool_cnt'];

						// Update mediadata if version is 0.0.4 or higher
						if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
							// Update entry (or add missing)
							//* DEBUG: */ debugOutput('*MEDIA/L:'.__LINE__.'*');
							updateMediadataEntry(array('total_orders', 'normal_orders'), 'add', 1);
						} // END - if

						//* DEBUG: */ debugOutput('*EXIT/L:'.__LINE__.'/'.$P);
						break;
					}
					// Is there send maximum mails?
					elseif (($GLOBALS['pool_cnt'] >= getConfig('max_send')) || ($count2 >= getConfig('max_send'))) {
						// There are some mails left to send for next round, so we reset the status back to NEW (=still not fully delivered)
						$add = '';
						if ($GLOBALS['pool_cnt'] <= $mailData['target_send']) $add = ", target_send=target_send-".$GLOBALS['pool_cnt'];
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='NEW', receivers='%s'" . $add . " WHERE `id`=%s LIMIT 1",
							array(
								implode(';', $temporaryReceivers),
								bigintval($mailData['id'])
							), __FILE__, __LINE__);

						//* DEBUG: */ debugOutput('*EXIT/L:'.__LINE__.'*');
						break;
					}

					// Free result
					SQL_FREERESULT($result_stats);
				} else {
					// User does not exists so we have add the sender's points back to sender's account
					if (($receivers['id'] == '0') || (empty($receivers['id']))) {
						// List was empty
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='SEND' WHERE `id`=%s LIMIT 1",
							array(bigintval($mailData['id'])), __FILE__, __LINE__);
					} else {
						// Is the userid set?
						if (isValidUserId($userid)) {
							// User does not exists, pay points back
							$points = getPaymentData($mailData['payment_id']);
							initReferralSystem();
							addPointsThroughReferralSystem('pool_payback', $mailData['sender_userid'], $points);

							// Add points together and remove user
							$pointsBack[$mailData['sender_userid']] += $points;
						} // END - if

						// Count up
						$count_back[$mailData['sender_userid']]++;
					}

					// Remove entry from list
					unset($temporaryReceivers[$key]);

					// Update receivers
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `receivers`='%s' WHERE `id`=%s LIMIT 1",
						array(implode(';', $temporaryReceivers), bigintval($mailData['id'])), __FILE__, __LINE__);
				}
			} // END - foreach
		} // END - if
	} // END - while

	// Is there points to "pay back"?
	if ((count($pointsBack) > 0) && (!empty($pointsBack[0]))) {
		// Walk through all points
		foreach ($pointsBack as $userid => $PB) {
			// Add points only when we have points left to add and a valid user id
			if (($PB > 0) && (isValidUserId($userid))) {
				// Prepare content
				$content = array(
					'points' => $PB
				);

				// We have to pay back some points to the sender (we add them directly :-P)
				if (fetchUserData($userid)) {
					// User account does exists, so we can safely pay back!
					$mailText = loadEmailTemplate('member_user_pool_back', $content, bigintval($userid));

					// Send mail out to member
					sendEmail($userid, '{--MEMBER_BACK_JACKPOT--}' . ' (' . $userid . ')', $mailText);
				} elseif (isExtensionActive('jackpot')) {
					// Add to jackpot
					addPointsToJackpot($PB);

					// Send mail out to admin
					sendAdminNotification('{--ADMIN_BACK_JACKPOT--}' . ' (' . $userid . ')', 'admin_user_pool_back', $content, 'admin');
				}
			} // END - if
		} // END - foreach
	} // END - if
} // END - if

// Free memory
SQL_FREERESULT($result_main);

// Remove variable
unset($mailText);

// [EOF]
?>
